﻿using C1.WPF.DataGrid;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace C1ProgressBar
{
    public partial class MainWindow : Window
    {
        const short columns = 1000;
        const int rows = 100000;
        BackgroundWorker worker = new BackgroundWorker();
        BackgroundWorker worker1 = new BackgroundWorker();
        public MainWindow()
        {
            InitializeComponent();
        }
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            info.Visibility = Visibility.Visible;
            grid.Opacity = 100;
            btn.Visibility = Visibility.Collapsed;

            for (int i = 0; i < columns; i++)
            {
                grid.Columns.Add(new DataGridNumericColumn()
                {
                    Header = new TextBlock()
                    {
                        Text = "Column" + (i + 1).ToString(),
                        TextAlignment = TextAlignment.Right,
                        VerticalAlignment = VerticalAlignment.Center,
                        Margin = new Thickness(0, 0, 5, 0),
                    },
                    Binding = new System.Windows.Data.Binding()
                    {
                        Path = new PropertyPath("[" + i + "]"),
                        Mode = System.Windows.Data.BindingMode.OneTime,
                    }
                });
            }
            progress.Minimum = 0;
            progress.Maximum = rows;

            worker.ProgressChanged += new ProgressChangedEventHandler(worker_ProgressChanged);
            worker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(worker_RunWorkerCompleted);
            worker.DoWork += new DoWorkEventHandler(worker_DoWork);
            worker.WorkerReportsProgress = true;
            worker.RunWorkerAsync();
        }
        void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            int id2 = Thread.CurrentThread.ManagedThreadId;
            Random rnd = new Random();

            var list = new List<List<short>>(rows);
            for (int i = 0; i < rows; i++)
            {
                if (i % 1000 == 0)
                {
                    worker.ReportProgress(0, i);
                    Thread.Sleep(20);
                }
                var values = new List<short>(columns);

                for (int j = 0; j < columns; j++)
                {
                    values.Add((short)rnd.Next(short.MaxValue));
                }

                list.Add(values);
            }

            e.Result = list;
        }
        void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            grid.ItemsSource = (IList)e.Result;

            info.Visibility = Visibility.Collapsed;
            grid.Visibility = Visibility.Visible;
        }
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            progress.Value = (int)e.UserState;
            txt.Text = string.Format("{0} / {1} rows",
                        ((int)e.UserState).ToString("n0", CultureInfo.CurrentCulture),
                        rows.ToString("n0", CultureInfo.CurrentCulture));
        }

        private void Button_Click1(object sender, RoutedEventArgs e)
        {
            info1.Visibility = Visibility.Visible;
            grid1.Opacity = 100;
            btn1.Visibility = Visibility.Collapsed;

            for (int i = 0; i < columns; i++)
            {
                grid1.Columns.Add(new DataGridNumericColumn()
                {
                    Header = new TextBlock()
                    {
                        Text = "Column" + (i + 1).ToString(),
                        TextAlignment = TextAlignment.Right,
                        VerticalAlignment = VerticalAlignment.Center,
                        Margin = new Thickness(0, 0, 5, 0),
                    },
                    Binding = new System.Windows.Data.Binding()
                    {
                        Path = new PropertyPath("[" + i + "]"),
                        Mode = System.Windows.Data.BindingMode.OneTime,
                    }
                });
            }
            progress.Minimum = 0;
            progress.Maximum = rows;

            worker1.RunWorkerCompleted += new RunWorkerCompletedEventHandler(worker_RunWorkerCompleted1);
            worker1.DoWork += new DoWorkEventHandler(worker_DoWork1);
            worker1.WorkerReportsProgress = true;
            worker1.RunWorkerAsync();
            progressIndicator.IsActive = true;
        }
        void worker_DoWork1(object sender, DoWorkEventArgs e)
        {
            int id2 = Thread.CurrentThread.ManagedThreadId;
            Random rnd = new Random();

            var list = new List<List<short>>(rows);
            for (int i = 0; i < rows; i++)
            {
                if (i % 1000 == 0)
                {
                    worker1.ReportProgress(0, i);
                    Thread.Sleep(20);
                }
                var values = new List<short>(columns);

                for (int j = 0; j < columns; j++)
                {
                    values.Add((short)rnd.Next(short.MaxValue));
                }

                list.Add(values);
            }
            e.Result = list;
        }
        void worker_RunWorkerCompleted1(object sender, RunWorkerCompletedEventArgs e)
        {
            grid1.ItemsSource = (IList)e.Result;

            grid1.Visibility = Visibility.Visible;

            progressIndicator.IsActive = false;
        }
    }
}
